//=========================================================
//
//	storage.c
//
//	Contains the storage for the in-memory mail index
//	and allows up to MAXMAIL mail items in a mailbox.
//
//	Also contains other global storage.
//
//=========================================================

// $Id: storage.c,v 1.3 1994/02/20 19:13:38 gbj Exp user $

/*
$Log: storage.c,v $
 * Revision 1.3  1994/02/20  19:13:38  gbj
 * Added alias global ver.
 *
 * Revision 1.2  1994/02/08  23:33:54  gbj
 * First public release.
 *
 * Revision 1.1  1994/02/08  03:16:14  gbj
 * Initial revision
 *
*/

#define MAXMAIL 100

#include "mailer.h"

// Must make this a linked list - one day perhaps...
MAILIX mailix[MAXMAIL];		// Runtime mailbox index
int maxmsgno;

// YUK, YUK, YUK - loads of global variables...
// These should be in a structure and a pointer to it passed
// around - one day perhaps.
char mailpath[128];		// Full pathname of mail directory
char mqueuepath[128];	// Full pathname of mqueue directory
char mbox[128];			// Full pathname of current mailbox
char sequence[128];		// Full pathname of sequence file
char txt[128];			// Full pathname of .txt file
char wrk[128];			// Full pathname of .wrk file
char tmp[128];			// Full pathname of .tmp file
char host[128];			// Hostname
char reply[128];		// Reply-To:
char name[128];			// Full Name
char from[128];			// From:
char edit[128];			// Full pathname of editor
char user[128];			// User mailbix id
char mail[128];			// Path to dir containing mail/mqueue dirs
char sig[128];			// Path to your signature file
char log[128];			// Name of outgoing mail mailbox
char alias[128];		// Path of your mail alias file.

FILE *mfd;				// Mailbox fd
FILE *sfd;				// Sequence fd
FILE *tfd;				// .txt fd
FILE *wfd;				// .wrk fd
FILE *xfd;				// .tmp fd

int cmsg;				// Current message
