#ifndef GLOBAL_H
#define GLOBAL_H

#ifndef COMPILER_H
#include <compiler.h>
#endif

#include "drivers.h"
#include "transprt.h"

/* IDs for the semaphores and mailboxes we'll need */
#if 0	/* I don't think we need these anymore */
#define POOL_SEMAPHORE		0x53544B4DL	/* "STKM" */
#define NET_SEMAPHORE		0x53544B4EL	/* "STKN" */
#define CIB_CHAIN_SEMAPHORE	0x53544B43L	/* "STKC" */
#endif /* 0 */
#define DMN_SEMAPHORE		0x53544B58L	/* "STKX" */
#ifdef DEBUG
#define DEBUG_SEMAPHORE		0x53544B44L	/* "STKD" */
#endif /* DEBUG */
#define DMN_MBOX		0x4353444DL	/* "GSDM" */

/* struct for Pmsg() */
typedef struct {
  long userlong1;
  long userlong2;
  short pid;
} PMSG;

typedef struct {
  char *name;
  char *value;
} Var;

extern DRV_HDR* __CDECL do_get_dftab __PROTO((char *));
extern int16 __CDECL do_ETM_exec __PROTO((char *));
 
extern char* __CDECL do_KRmalloc __PROTO((int32));
extern void __CDECL do_KRfree __PROTO((void *));
extern int32 __CDECL do_KRgetfree __PROTO((int16));
extern char* __CDECL do_KRrealloc __PROTO((char *, int32));
extern char* __CDECL do_get_err_text __PROTO((int16));
extern char* __CDECL do_getvstr __PROTO((char *));
extern int16 __CDECL do_carrier_detect __PROTO((void));
extern int16 __CDECL do_TCP_open __PROTO((uint32, int16, int16, uint16));
extern int16 __CDECL do_TCP_close __PROTO((int16, int16));
extern int16 __CDECL do_TCP_send __PROTO((int16, char* , int16));
extern int16 __CDECL do_TCP_wait_state __PROTO((int16, int16, int16));
extern int16 __CDECL do_TCP_ack_wait __PROTO((int16, int16));
extern int16 __CDECL do_UDP_open __PROTO((uint32, int16));
extern int16 __CDECL do_UDP_close __PROTO((int16));
extern int16 __CDECL do_UDP_send __PROTO((int16, char *, int16));
extern int16 __CDECL do_CNkick __PROTO((int16));
extern int16 __CDECL do_CNbyte_count __PROTO((int16));
extern int16 __CDECL do_CNget_char __PROTO((int16));
extern NDB* __CDECL do_CNget_NDB __PROTO((int16));
extern int16 __CDECL do_CNget_block __PROTO((int16, char *, int16));
extern void __CDECL do_housekeep __PROTO((void));
extern int16 __CDECL do_resolve __PROTO((char *, char **, uint32 *, int16));
extern void __CDECL do_ser_disable __PROTO((void));
extern void __CDECL do_ser_enable __PROTO((void));
extern int16 __CDECL do_set_flag __PROTO((int16));
extern void __CDECL do_clear_flag __PROTO((int16));
extern CIB* __CDECL do_CNgetinfo __PROTO((int16));

extern int init_mem __PROTO((void));
extern int init_net __PROTO((void));
extern int init_stubs __PROTO((void));
extern int load_config_file __PROTO((void));
#ifdef DEBUG
extern void debug(const char *, ...);
#endif

extern CONFIG driver_config;
extern DRV_LIST driver;
extern TPL trampoline;

#endif /* GLOBAL_H */
