#ifndef PIPE_H
#define PIPE_H

#include <types.h>
#include "drivers.h"
#include "transprt.h"


typedef union {
  struct { int op; } common;
  struct { int op; uint32 hostaddr; int16 port; int16 tos; uint16 obsize; }
    P_TCP_open;
  struct { int op; int16 fd; int16 timeout; } P_TCP_close;
  struct { int op; int16 fd; char *buf; int16 buflen; } P_TCP_send;
  struct { int op; int16 fd; int16 state; int16 timeout; } P_TCP_wait_state;
  struct { int op; uint32 hostaddr; int16 port; } P_UDP_open;
  struct { int op; int16 fd; } P_UDP_close;
  struct { int op; int16 fd; char *buf; int16 buflen; } P_UDP_send;
  struct { int op; int16 fd; } P_CNbyte_count;
  struct { int op; int16 fd; } P_CNget_char;
  struct { int op; int16 fd; } P_CNget_NDB;
  struct { int op; int16 fd; char *buf; int16 len; } P_CNget_block;
  struct { int op; char *hostname; char **realname; uint32 *addrs;
	   int16 naddrs; } P_resolve;
  struct { int op; int16 fd; } P_CNgetinfo;
  struct { int op; int32 size; } P_KRmalloc;
  struct { int op; char *mem; } P_KRfree;
  struct { int op; int16 flag; } P_KRgetfree;
  struct { int op; char *mem; int32 newsize; } P_KRrealloc;
  struct { int op; char *var; } P_getvstr;
} Daemon_Op;

typedef union {
  int16 ret_int16;
  char *ret_charptr;
  int32 ret_int32;
  NDB  *ret_NDBptr;
  CIB  *ret_CIBptr;
} Daemon_Retval;

#if 0
typedef struct {
  unsigned long magic;
#define GSDAEMON_MAGIC	0x476c7565L	/* 'Glue' */
  Daemon_Op *OP;
  Daemon_Retval *RET;
  pid_t daemon_pid;
  pid_t user_pid;
} Daemon_Interface;
#endif

/* daemon ops */
#define OP_TCP_OPEN		1
#define OP_TCP_CLOSE		2
#define OP_TCP_SEND		3
#define OP_TCP_WAIT_STATE	4
#define OP_UDP_OPEN		5
#define OP_UDP_CLOSE		6
#define OP_UDP_SEND		7
#define OP_CNBYTE_COUNT		8
#define OP_CNGET_CHAR		9
#define OP_CNGET_NDB		10
#define OP_CNGET_BLOCK		11
#define OP_RESOLVE		12
#define OP_CNGETINFO		13
#define OP_KRMALLOC		14
#define OP_KRFREE		15
#define OP_KRGETFREE		16
#define OP_KRREALLOC		17
#define OP_GETVSTR		18
#define OP_MAX			18


#if 0
extern Daemon_Op OP;
extern Daemon_Retval RET;
extern Daemon_Interface *DMN;
#endif

void send_op __PROTO((Daemon_Op *, Daemon_Retval *));

#endif /* PIPE_H */
